/* Artillery par PulkoMandy */

#include "artillery.h"

SDL_Surface* screen; //L'cran
SFont_Font* font; //une police de caractres

int main(int argc, char** argv)
{
	/****************
	 * Dclarations *
	 ****************/

	SDL_Surface* temp; //l'cran, un temp pour les textes et divers blitts.
	SDL_Event event; //venement (gestion souris, clavier, etc)
	unsigned int i,x,xsommet,y,ysommet; //Un compteur de boucles, et les coordonnes de diverses choses
	unsigned short int ybleu,yrouge; //position verticales des chateaux
	#define xrouge 700 //positions horizontales constantes
	#define xbleu 50
	float j;
	char tmp[64]; //Chane de caractre temporaire pour traiter les chaines avant affichage avec sfont
	
	unsigned short int anglebleu=45,poudrebleu=150,anglerouge=45,poudrerouge=150; //les rglages des joueurs
	char tour='r'; //Joueur en cours: r= rouge et b=bleu
	
	int collisions[800]; //Table des altitudes pour grer les collisions
	
	Mix_Music* zik;

	/******************
	 * Initialisation *
	 ******************/

	//Met l'cran en place
	if(SDL_Init(SDL_INIT_VIDEO | SDL_INIT_AUDIO)<0)
	{
		printf("Initialisation choue");
		exit(1);
	}
	atexit(SDL_Quit); //Pour sortir du prog proprement.
	screen=SDL_SetVideoMode(800,600,15,SDL_HWSURFACE);
	if(screen==NULL)
	{
		printf("Mauvais mode video");
		exit(1);
	}

	//Charge la police
	font = SFont_InitFont(IMG_Load("5pxtinyfont.png"));
	if(!font) {
		fprintf(stderr, "Erreur de chargement de la police de caractres!");
		exit(1);
	}
	
	if (Mix_OpenAudio(44100, AUDIO_S16SYS, 2, 1024)<0)
		fprintf(stderr, "INIT AUDIO ECHOUEE\n");
	zik=Mix_LoadMUS("music.xm");
	if (zik==NULL)
		fprintf(stderr, "CHARGEMENT MUSIQUE ECHOUE\n");
	Mix_PlayMusic(zik, -1);
	
	
	SDL_ShowCursor(SDL_ENABLE); //affiche la souris
	
	/*************************
	 * Dessin de l'interface *
	 *************************/

	hlineRGBA(screen,1  ,799,551,255,255,255,255); //Ligne horizontale du haut
	hlineRGBA(screen,1  ,799,599,255,255,255,255); //Ligne du bas

	vlineRGBA(screen,1  ,550,599,255,255,255,255); //Premire verticale

	vlineRGBA(screen,40 ,550,599,255,255,255,255); //Boutons haut bas
	vlineRGBA(screen,50 ,550,599,255,255,255,255); //..
	hlineRGBA(screen,40 ,50 ,575,255,255,255,255); //Haut Bas J1

	vlineRGBA(screen,100,550,599,255,255,255,255); //Boutons poudre
	vlineRGBA(screen,90 ,550,599,255,255,255,255); //..
	hlineRGBA(screen,90 ,100,575,255,255,255,255); //Poudre J1

	vlineRGBA(screen,700,550,599,255,255,255,255); //Joueur 2

	vlineRGBA(screen,740,550,599,255,255,255,255); //Haut bas
	vlineRGBA(screen,750,550,599,255,255,255,255);
	hlineRGBA(screen,740,750,575,255,255,255,255); //Haut Bas J2

	vlineRGBA(screen,790,550,599,255,255,255,255); //Poudre
	vlineRGBA(screen,799,550,599,255,255,255,255);
	hlineRGBA(screen,790,800,575,255,255,255,255); //Poudre J2
	
	hlineRGBA(screen,43,47,562,255,255,255,255);
	vlineRGBA(screen,45,560,564,255,255,255,255); //+ poudre bleu
	
	hlineRGBA(screen,93,97,562,255,255,255,255);
	vlineRGBA(screen,95,560,564,255,255,255,255); //+ angle bleu
	
	hlineRGBA(screen,43,47,562+25,255,255,255,255); //- poudre bl
	
	hlineRGBA(screen,93,97,562+25,255,255,255,255); // + agl bl
	
	hlineRGBA(screen,793,797,562,255,255,255,255);
	vlineRGBA(screen,795,560,564,255,255,255,255); //+ poudre rg
	
	hlineRGBA(screen,743,747,562,255,255,255,255);
	vlineRGBA(screen,745,560,564,255,255,255,255); //+ angle r
	
	hlineRGBA(screen,793,797,562+25,255,255,255,255); //- poudre r
	
	hlineRGBA(screen,743,747,562+25,255,255,255,255); //+ agl r

	/****************************
	 * Mise en place du terrain *
	 ****************************/
	srand(time(NULL));

	y=500-random()*100.0/RAND_MAX;
	x=100+random()*150.0/RAND_MAX;
	
	boxRGBA(screen,0,0,799,550,50,200,255,255); //Couleur du ciel

	for(i=0;i<=x;i++) //premier terrain plat
	{
		vlineRGBA(screen,i,y,550,50,200,0,255); //On dessine
		collisions[i]=y; //Et on stocke dans la table pour pouvoir tester
	}
	
	BlitImg(screen,xbleu,y-50,"castle1.png"); //On affiche le chateau bleu
	ybleu=y-50; //Il fait 50 pixels de haut

	xsommet=200+random()*100.0/RAND_MAX;
	ysommet=400-random()*150.0/RAND_MAX;
	
	for(i=0;i<=xsommet;i++) // Monte de la montagne
	{
		collisions[i+x]=(cos(3.141592654*(float)i/xsommet)-1)*ysommet/2+y+1;
		vlineRGBA(screen,i+x,collisions[i+x],550,50,200,0,255);
	}

	xsommet+=x;
	ysommet-=y;

	x=700-random()*150.0/RAND_MAX;
	y=500-random()*100.0/RAND_MAX;
  
	ysommet+=y;

	for(i=0;i<=x-xsommet;i++) //descente de la montagne
	{
		collisions[i+xsommet]=(cos(3.141592654*((float)i/(x-xsommet)-1))-1)*ysommet/2+y+1;
		vlineRGBA(screen,i+xsommet,collisions[i+xsommet],550,50,200,0,255);
	}

	for(i=x;i<=799;i++) // Deuxime plat (droite)
	{
		collisions[i]=y;
		vlineRGBA(screen,i,y,550,50,200,0,255);
	}

	BlitImg(screen,xrouge,y-50,"castle2.png");
	yrouge=y-50;

	/**************
	 * Les textes *
	 **************/
	SFont_Write (screen, font, 350,555,"Artillery par PulkoMandy - Version 0.2");
	DisplayStatusText("C'est au tour du joueur rouge");
	
	SDL_UpdateRect(screen,0,0,0,0); //update de l'cran pour tout afficher

	/*********************
	 * Boucle principale *
	 *********************/
	while(1)
	{
		while(tour=='r')
		{
			SDL_WaitEvent(&event); //attente d'vnement
		
			switch (event.type)
			{
				case SDL_QUIT:
					goto end; //quitter le programme
				break;
				case SDL_MOUSEBUTTONDOWN:
					if (event.button.y>575) //On est tout en bas de l'cran, du ct des boutons '-'
					{
						if (event.button.x>740 && event.button.x<750 && anglerouge!=0)
						{ //On diminue l'angle
							while(1)
							{
								if (SDL_PollEvent(&event))
									if (event.type==SDL_MOUSEBUTTONUP) break;
								SDL_Delay(100);
								anglerouge--;
								boxRGBA(screen, 702, 552, 739, 600, 0, 0, 0, 255);
								sprintf(tmp,"%d",anglerouge);
								SFont_Write(screen,font,703,553,tmp);
								SDL_UpdateRect(screen,702,552,38,10);
							}
						}
						else if (event.button.x>790 && poudrerouge!=0)
						{ //On diminue la poudre
							while(1)
							{
								if (SDL_PollEvent(&event))
									if (event.type==SDL_MOUSEBUTTONUP) break;
								SDL_Delay(100);
								poudrerouge--;
								boxRGBA(screen, 752, 552, 788, 600, 0, 0, 0, 255);
								sprintf(tmp,"%dg",poudrerouge);
								SFont_Write(screen,font,753,553,tmp);
								SDL_UpdateRect(screen,752,552,38,10);
							}
						}
					}
					else if(event.button.y>551)
					{ //Ici on est du ct des '+'
						if (event.button.x>740 && event.button.x<750 && anglerouge <180)
						{ //On augmente l'angle
							while(1)
							{
								if (SDL_PollEvent(&event))
									if (event.type==SDL_MOUSEBUTTONUP) break;
								SDL_Delay(100);
								anglerouge++;
								boxRGBA(screen, 702, 552, 739, 600, 0, 0, 0, 255);
								sprintf(tmp,"%d",anglerouge);
								SFont_Write(screen,font,703,553,tmp);
								SDL_UpdateRect(screen,702,552,38,10);
							}
						}
						else if (event.button.x>790)
						{ //On augmente la poudre
							while(1)
							{
								if (SDL_PollEvent(&event))
									if (event.type==SDL_MOUSEBUTTONUP) break;
								SDL_Delay(100);
								poudrerouge++;
								boxRGBA(screen, 752, 552, 788, 600, 0, 0, 0, 255);
								sprintf(tmp,"%dg",poudrerouge);
								SFont_Write(screen,font,753,553,tmp);
								SDL_UpdateRect(screen,752,552,38,10);
							}
						}
					}
					if (event.button.x<740 && event.button.x>700 && event.button.y>551 )
					{ //Ici on lance le boulet
						float tangente;
						y=0;
						tour='b'; //Aprs le tir on devra passer au bleu, sauf si on le touche
						for(x=1;x<xrouge && yrouge-y<600;x++)
						{
							tangente=tan(anglerouge*PI/180.0);
							y=-0.1*x*x*(1+tangente*tangente)/(float)poudrerouge+x*tangente;
							pixelRGBA(screen,xrouge-x+25,yrouge-y,255,0,0,255);
							SDL_UpdateRect(screen,1,1,790,590);
							if (xrouge-x+25<xbleu+50 && xrouge-x+25>xbleu && yrouge-y>ybleu && yrouge-y<ybleu+50)
							{ //On a atteint le chateau ennemi
								DisplayStatusText("Le joueur rouge remporte cette partie");
								tour='e'; //Partie termine
								break;
							}
							if (yrouge-y>collisions[xrouge-x+25])
							{ //Le boulet touche le sol...
								DisplayStatusText("Cible manquee! C'est au tour du joueur bleu.");
								break; //Pas la peine de continuer, on passe au tour du bleu direct
							}
						}
					}
				break;
			}
		}	
			
		while(tour=='b')
		{
			SDL_WaitEvent(&event); //attente d'vnement
			
			switch (event.type)
			{
				case SDL_QUIT:
					goto end; //quitter le programme
				break;
				case SDL_MOUSEBUTTONDOWN:
					if (event.button.y>575)
					{
						if (event.button.x>40 && event.button.x<50 && anglebleu!=0)
						{
							while(1)
							{
								if (SDL_PollEvent(&event))
									if (event.type==SDL_MOUSEBUTTONUP) break;
								SDL_Delay(100);
								anglebleu--;
								boxRGBA(screen, 2, 552, 39, 600, 0, 0, 0, 255);
								sprintf(tmp,"%d",anglebleu);
								SFont_Write(screen,font,3,553,tmp);
								SDL_UpdateRect(screen,2,552,38,10);
							}
						}
						else if (event.button.x>90 && event.button.x<100 && poudrebleu!=0)
						{
							while(1)
							{
								if (SDL_PollEvent(&event))
									if (event.type==SDL_MOUSEBUTTONUP) break;
								SDL_Delay(100);
								poudrebleu--;
								boxRGBA(screen, 52, 552, 88, 600, 0, 0, 0, 255);
								sprintf(tmp,"%d",poudrebleu);
								SFont_Write(screen,font,53,553,tmp);
								SDL_UpdateRect(screen,52,552,38,10);
							}
						}
					}
					else if(event.button.y>551)
					{
						if (event.button.x>40 && event.button.x<50 && anglebleu!=180)
						{
							while(1)
							{
								if (SDL_PollEvent(&event))
									if (event.type==SDL_MOUSEBUTTONUP) break;
								SDL_Delay(100);
								anglebleu++;
								boxRGBA(screen, 2, 552, 39, 600, 0, 0, 0, 255);
								sprintf(tmp,"%d",anglebleu);
								SFont_Write(screen,font,3,553,tmp);
								SDL_UpdateRect(screen,2,552,38,10);
							}
						}
						else if (event.button.x>90 && event.button.x<100)
						{
							while(1)
							{
								if (SDL_PollEvent(&event))
									if (event.type==SDL_MOUSEBUTTONUP) break;
								SDL_Delay(100);
								poudrebleu++;
								boxRGBA(screen, 52, 552, 88, 600, 0, 0, 0, 255);
								sprintf(tmp,"%dg",poudrebleu);
								SFont_Write(screen,font,53,553,tmp);
								SDL_UpdateRect(screen,52,552,38,10);
							}
						}
					}
				
					if (event.button.x<40 && event.button.y>551 )
						{ //Ici on lance le boulet
						float tangente;
						y=0;
						tour='r';
						for(x=0;x+xbleu<800 && x+xbleu>0 && ybleu-y<600;x++)
						{
							tangente=tan(anglebleu*PI/180.0);
							y=-0.1*x*x*(1+tangente*tangente)/(float)poudrebleu+x*tangente;
							pixelRGBA(screen,xbleu+x+25,ybleu-y,0,0,255,255);
							SDL_UpdateRect(screen,1,1,790,590);
							if (xbleu+x+25<xrouge+50 && xbleu+x+25>xrouge && ybleu-y>yrouge && ybleu-y<yrouge+50)
							{ //On a atteint le chateau ennemi
								DisplayStatusText("Le joueur bleu remporte cette partie");
								tour='e'; //Partie termine
								break;
							}
							if (ybleu-y>collisions[xbleu+x+25])
							{ //Le boulet touche le sol...
								DisplayStatusText("Cible manquee! c'est au tour du joueur rouge.");
								break; //Pas la peine de continuer, on passe au tour du rouge direct
							}
						}
					}
				break;
			}
		}
		
		if(tour=='e')
		{//Partie termine...
			SDL_WaitEvent(&event); //attente d'vnement
			if (event.type==SDL_QUIT) break; //quitter le programme
		}
	}

end:
	Mix_CloseAudio();
	SFont_FreeFont(font); //librer la police
	return 0;
}

/*************
 * Fonctions *
 *************/
void BlitImg(SDL_Surface* screen,int x,int y, char* filename)
{
	SDL_Surface* temp;
	SDL_Rect recdest={x,y,0,0};

	temp=IMG_Load(filename);
	SDL_BlitSurface(temp,NULL,screen,&recdest);
	SDL_FreeSurface(temp);
	SDL_UpdateRect(screen,x,y,temp->w,temp->h);
	return;
}

void DisplayStatusText(char* texte)
{
	boxRGBA(screen, 350, 565, 560, 585, 0, 0, 0, 255);
	SFont_Write(screen,font,360,565,texte);
	SDL_UpdateRect(screen,360,565,200,20); //update de l'cran pour afficher
}
